#!/bin/sh
#
#   die Dateinamen mssen bis zum Typ (scan, fax, ..) 22 Zeichen lang sein: 21.06.04_18x41x32_scan,  
#    21.06.04_18x41x32_faxx, ..
#   ssh-Schluessel-Austausch mit Suse 9.2 notwendig. 
#
# Praxiskennung fr Datenbank sourcen

. ./praxis


ping -c 1 suse92
rueck=$?
[ $rueck != 0 ] && ( echo "suse92 ... nicht erreichbar" | logger; sleep 10; exit )


[ -f ekorb.txt ] || { touch ekorb.txt; exit 1; }

ping -c 1 suse92
[ $? ] || (echo "Suse92 nicht erreichbar" | logger; sleep 10; exit)


ls -1tr | grep '^x[[:digit:]]\{14\}_[[:alpha:]]\{4\}_[[:digit:]]' >/tmp/~scan_$$;
 read n < /tmp/~scan_$$  # nur eine Zeile einlesen, der Rest beim nchsten Aufruf. 
if [ "$n" == "" ]; then 
   echo "leer"
   exit 0
fi 
 
echo "Neuzugang!: " $n   # z.B. x20040625012654_scan_2.tif, x20041005200120_uplo_1.jpg
# x am Anfang wegmachen
mv $n ${n#x}
n=`echo ${n#x}`   # z.B. n="20040625012654_scan_2.tif"

# Typbestimmung
z=`echo ${n%_*}`;zz=`echo ${z#*_}`   # zz="scan", oder "tiff" oder "pict"

case $zz in
     'scan' )
        echo "scan erkannt!"
        # tif nach tif: Grenreduzierung auf 5%
        convert $n "$n".tif; rm $n; mv "$n".tif $n
        chown david.users $n
        chmod 666 $n
        # thumbnail
        #convert -geometry 200x200 $n thumb/_${n%%tif}png 
        convert $n thumb/_${n%%tif}png 
        chown david.users thumb/_${n%%tif}png
        chmod 666 thumb/_${n%%tif}png
        echo $n
        dokTyp="scan"
        ;;
     'faxx' )
        echo "fax erkannt!"
        n=${n%.tif}
        # /usr/bin/fax2ps $n.tif > $n.ps
        # /usr/bin/tiff2ps -a $n.tif > $n.ps
        /usr/bin/tiff2ps -a -h 11.7 -w 8.5 $n.tif > $n.ps
        /usr/bin/ps2pdf $n.ps > $n.pdf

	# und nun eine um 180Grad gedrehte Variante ... fr den Fall, da getauscht wird
	/usr/bin/convert $n.tif -rotate 180 rotate180_$n.tif
	/usr/bin/tiff2ps -a -h 11.7 -w 8.5 rotate180_$n.tif > rotate180_$n.ps
        /usr/bin/ps2pdf rotate180_$n.ps > rotate180_$n.pdf
        chown david.users rotate180_$n.pdf
        chmod 666 rotate180_$n.pdf
	
        rm $n.tif
        rm $n.ps
        rm rotate180_$n.tif
        rm rotate180_$n.ps

        n=$n".pdf"
        dokTyp="faxx"
        chown david.users $n
        chmod 666 $n
        echo "****** Name des pdf: "$n
        ;;
     'uplo' ) 
        echo "upload erkannt!"
        # falls jpg oder jpeg dann durch convert-Aufruf komprimieren
        extension=${n#*.}
        if    [ "$extension" == "jpg" ] || [ "$extension" == "jpeg" ] \
	   || [ "$extension" == "JPG" ] || [ "$extension" == "JPEG" ]; then 
          convert $n y"$n" &&  rm $n && mv y"$n" $n
        fi
        chown david.users $n
        chmod 666 $n
        echo $n
        dokTyp="uplo"
        ;;
      * ) 
        dokTyp=""
        mv _$n unbekannt_$n;  
        echo "unbekannter Dokumententyp: " $n
        exit
        ;;
esac
echo "============== case ende ==========="

ssh suse92 "echo XXX;date" &>/tmp/check_ssh.txt
cat /tmp/check_ssh.txt >> /tmp/check_ssh2.txt

mv $n _$n   # ein _ vorne anstellen, Variable $n bleibt aber ohne "-" !!!!

# Datum (timestamp) der Datei extrahieren:
#Bsp:       _     s          c          a         n      _     1     .    t           i          f 
timest=${n%%_[[:alpha:]][[:alpha:]][[:alpha:]][[:alpha:]]_[[:digit:]]*.[[:alpha:]][[:alpha:]][[:alpha:]]}

#echo "select datEin from d where datEin=$timest;"
#t=`echo "select datEin from d where datEin=$timest;" |  mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME`
ttt="select datEin from d where datEin=$timest;"
t=$(ssh suse92 "echo '$ttt' | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME")
echo "t: " $t 
if [ "$t" != "" ] && [ "$dokTyp" == "scan" ] ; then 
   echo $timest " ist schon in Tab b im ekorb"
   # in scans einen weiteren Eintrag vornehmen, vorher die zum $timest zugehrige id herausfinden und 
   # aus scans die nchste laufende Nummer fr Platz
   sql="select d.id from d,scans where d.id=scans.id_d and d.datEin="$timest" order by scans.platz;"
   echo "SQL: " $sql 
   ssh suse92 "echo '$sql' | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME" > $$.tmp
   for i in 1 2; do read l;done < $$.tmp   #Spaltenberschrift, zweite Zeile erst ist der Wert
   id_=$l


   sql="select scans.platz from d,scans where d.id=scans.id_d and d.datEin="$timest" order by scans.platz desc;"
   echo "SQL: " $sql
   ssh suse92 "echo '$sql' | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME" > $$.tmp
   for i in 1 2; do read l;done < $$.tmp #Spaltenberschrift, zweite Zeile erst ist der Wert
   platz_=$l
      
   sql="insert into scans (id,id_d,dokElement,platz) values (NULL,"$id_",'_$n',"$platz_"+1);"
   echo "SQL: " $sql
   echo $sql | ssh suse92 "cat | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME" 2>$$.err
   
   #rm $$.tmp
   rm $$.err
   
else 
   echo $timest " ist noch nicht in Tab b oder dokTyp != 'scan'"
   sql="insert into d (id,patNr,lastChange,datEin,typ,dokName,vonAn,vonAnNam,fach,datUser,dok,bem) values"
   sql=$sql"(NULL,NULL,"$timest","$timest","


   case $dokTyp in
     'scan' )
        sql=$sql"'scan','',NULL,NULL,NULL,"$timest",'',NULL);"
        echo "sql: " $sql;
        sql=$sql" insert into scans (id,id_d,dokElement,platz) values(NULL,LAST_INSERT_ID(),'_$n',1);"
 #      sql="insert into scans values(NULL,LAST_INSERT_ID(),'_$n',1);"
        echo "sql: " $sql;
        echo $sql | ssh suse92 "cat | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME" &>$$.err
        echo $sql >>/var/log/ekorb.log
        cat $$.err >> /var/log/ekorb.log
        echo 'select LAST_INSERT_ID();' | ssh suse92 "cat | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME "
        ;;
     'faxx' )
        sql=$sql"'fax','fax',NULL,NULL,NULL,"$timest",'_$n',NULL);"
        echo "sql: " $sql;
        echo $sql | ssh suse92 "cat | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME" 2>$$.err
        echo $sql >>/var/log/ekorb.log
        cat $$.err >> /var/log/ekorb.log
        ;;
     'uplo' )
        sql=$sql"'upload','hoch',NULL,NULL,NULL,"$timest",'_$n',NULL);"
        echo "sql: " $sql;
        echo $sql | ssh suse92 "cat | mysql -hlocalhost -u$SQL_USER -p$SQL_PASS $DB_NAME" 2>$$.err
        echo $sql >>/var/log/ekorb.log
        cat $$.err >> /var/log/ekorb.log
        ;;
     * )
       echo "Fehler: Diesen FAll darf es nicht mehr geben! Vorher schon 'exit'"
        ;;
   esac
fi   



rm /tmp/~scan_$$ 
rm *.err
rm *.tmp
